#include <Arduino.h>
#include "ESP32_IOShield.h"

// Pin Redirection Arrays

int ESP32IO_SwitchPin[2]={ESP32IO_S1_PIN, ESP32IO_S2_PIN};
int ESP32IO_RelayPin[4]={ESP32IO_R1_PIN, ESP32IO_R2_PIN, ESP32IO_R3_PIN, ESP32IO_R4_PIN};
int ESP32IO_ThermPin[6]={ESP32IO_T1_PIN, ESP32IO_T2_PIN, ESP32IO_T3_PIN, ESP32IO_T4_PIN, ESP32IO_T5_PIN, ESP32IO_T6_PIN};

void ESP32_IOShield_Init() {

  for(int i=0; i<4; i++) {
    pinMode(ESP32IO_RelayPin[i], OUTPUT);
    digitalWrite(ESP32IO_RelayPin[i], HIGH);
  }
  
  pinMode(ESP32IO_S1_PIN, INPUT_PULLUP);
  pinMode(ESP32IO_S2_PIN, INPUT_PULLUP);
}

int ESP32_IOShield_SwitchState(int s) {
      if(digitalRead(ESP32IO_SwitchPin[s-1]) == LOW) return 1;
      return 0;
}

void ESP32_IOShield_SetRelay(int r, int s) {
      if(s > 0) digitalWrite(ESP32IO_RelayPin[r-1], LOW);
      else digitalWrite(ESP32IO_RelayPin[r-1], HIGH);
}